---
include:
  - project: 'ix.ai/ci-templates'
    file: '/common.yml'

.clone_before: &clone_before
  - git --version || apk add --no-cache git || (apt-get update && apt-get -y install --no-install-recommends git)
  - git clone https://gitlab.com/ix.ai/ci-templates.git ci-templates

test:
  image: public.ecr.aws/docker/library/python:latest@sha256:385ccb8304f6330738a6d9e6fa0bd7608e006da7e15bc52b33b0398e1ba4a15b
  stage: test
  retry: 2
  before_script:
    - *clone_before
    - if [ -f ci-templates/scripts/github-status.sh ]; then BUILD_STATUS=pending ci-templates/scripts/github-status.sh; fi
    - touch "/tmp/${CI_PROJECT_NAME}-${CI_COMMIT_SHA}-failure"
  after_script:
    - if [ -f "/tmp/${CI_PROJECT_NAME}-${CI_COMMIT_SHA}-failure" ]; then export BUILD_STATUS=failure; else export BUILD_STATUS=success; fi
    - if [ -f ci-templates/scripts/github-status.sh ]; then ci-templates/scripts/github-status.sh; fi
  script:
    - pip install --break-system-packages -U pip pylint
    - find . -name .git -type d -prune -o -name requirements.txt -print0 | xargs -0 -P $(nproc) -r -n1 pip install -r
    - find . -name .git -type d -prune -o -type f -name \*.py -print0 | xargs -0 -P $(nproc) -r -n1 pylint --rcfile=${CI_PROJECT_DIR}/.pylintrc
    - find . -name test.sh -maxdepth 1 -exec sh {} \;
    - rm -f "/tmp/${CI_PROJECT_NAME}-${CI_COMMIT_SHA}-failure"
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
    - if: $CI_COMMIT_TAG